﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interactivity;

namespace FluidMove
{
 public class InvalidateListBoxItemAfterLoadBehavior : Behavior<FrameworkElement>
 {
  public InvalidateListBoxItemAfterLoadBehavior()
  {
  }

  protected override void OnAttached()
  {
   base.OnAttached();
   
   this.AssociatedObject.Loaded += AssociatedObject_Loaded;
  }

  protected override void OnDetaching()
  {
   base.OnDetaching();
  }

  private void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
  {
   FrameworkElement ancestor = this.AssociatedObject;
   
   while (ancestor != null)
   {
    if (ancestor is ListBoxItem)
    {
     ancestor.InvalidateArrange();
     return;
    }
    ancestor = VisualTreeHelper.GetParent(ancestor) as FrameworkElement;
   }
  }
 }
}